/*
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 *  0. You just DO WHAT THE FUCK YOU WANT TO.
 */
#include<stdio.h>
#include<stdlib.h>
#include<dirent.h>
#include<string.h>
#include<errno.h>

#define DEFAULT_DIRECTORY "."

void usage (char *binary)
{
    fprintf(stdout, "%s [-h] <directory>\n", binary);
}

int main(int argc, char **argv)
{
    int new = 0;
    DIR* rep = NULL;
    char directory[255];
    struct dirent *readFile = NULL;

    if (argc > 1) {
        if ( !strcmp(argv[1], "-h") || !strcmp(argv[1], "--help")) {
            usage(argv[0]);
            return 1;
        }
        strncpy(directory, argv[1], 255);
    } else {
        strncpy(directory, DEFAULT_DIRECTORY, 255);
    }

    rep = opendir(directory);
    if(rep != NULL) {

        while( (readFile = readdir(rep)) != NULL){
            if(strcmp(readFile->d_name, ".") && strcmp(readFile->d_name, "..")){
                new++;
            }
        }

        if(closedir(rep) == -1){
            exit (-1);
        }
    } else {
        switch (errno) {
            case EACCES:
                fprintf(stderr,"bad permissions : %s/\n", directory);
                break;
            case ENOTDIR:
                fprintf(stderr, "not a directory : %s.\n", directory);
                break;
            default:
                fprintf(stderr, "erreur #%d\n",errno);
        }
    }

    printf("%u\n",new);
    return 0;
}
